## libsdl2-mixer 2.6.3+dfsg

=== debian/changelog ===
libsdl2-mixer (2.6.3+dfsg-1) unstable; urgency=medium

  [ Debian Janitor ]
  * d/control: Remove version constraints unnecessary since Debian 10
  * d/upstream/metadata: Add

  [ Simon McVittie ]
  * New upstream stable release
    - Functionally equivalent to 2.6.2+dfsg-2
    - Drop patch from 2.6.2+dfsg-2, applied upstream
  * d/copyright: Update
  * d/control: Update standards version to 4.6.2 (no changes needed)
  * d/control: Remove version constraints unnecessary since Debian 11
  * d/upstream/metadata: Add Repository field
  * d/tests: Run Xvfb with -noreset to make the test more reliable.
    See #981201.
  * d/tests: Instruct xvfb-run to choose a server number automatically
  * d/watch: Only watch for 2.x versions.
    The upstream 'main' branch now targets SDL 3 (under development), and
    should be packaged separately as a libsdl3-mixer source package.

 -- Simon McVittie <smcv@debian.org>  Sat, 15 Jul 2023 18:05:33 +0100

## libsdl2-mixer 2.8.0%2Bdfsg

=== debian/tests/control ===
Tests: libsdl2-mixer-dev
Restrictions: allow-stderr, superficial
Depends:
 alsa-utils,
 build-essential,
 cmake,
 libsdl2-mixer-dev,
 ninja-build,
 pkg-config,
 xauth,
 xvfb,

## libsdl2-mixer 2.8.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

# See docs/release_checklist.md
set(MAJOR_VERSION 2)
set(MINOR_VERSION 8)
set(MICRO_VERSION 0)
set(SDL_REQUIRED_VERSION 2.0.9)

include(PrivateSdlFunctions)
sdl_calculate_derived_version_variables()

if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
    message(FATAL_ERROR "Prevented in-tree built. Please create a build directory outside of the SDL_mixer source code and call cmake from there")
endif()

project(SDL2_mixer
    LANGUAGES C
    VERSION "${FULL_VERSION}"
)

message(STATUS "Configuring ${PROJECT_NAME} ${PROJECT_VERSION}")

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
    set(SDL2MIXER_ROOTPROJECT ON)
else()
    set(SDL2MIXER_ROOTPROJECT OFF)
endif()

set(SDL2MIXER_SAMPLES_DEFAULT ${SDL2MIXER_ROOTPROJECT})
if(ANDROID)
    set(SDL2MIXER_SAMPLES_DEFAULT OFF)
endif()

# option() honors normal variables.
cmake_policy(SET CMP0077 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)

if(POLICY CMP0112)
    # Target file component generator expressions do not add target dependencies.
    cmake_policy(SET CMP0112 NEW)
endif()

# Set defaults preventing destination file conflicts
set(SDL2MIXER_DEBUG_POSTFIX "d"
    CACHE STRING "Name suffix for debug builds")
mark_as_advanced(SDL2MIXER_DEBUG_POSTFIX)

if(POLICY CMP0099)
    # Make `INTERFACE_LINK_DIRECTORIES` a transitive usage requirement.
    # This is needed for static dependencies which have transitive dependencies
    # outside of compiler default search paths.
    cmake_policy(SET CMP0099 NEW)
endif()

# Assume MSVC projects don't have a package manager and need vendored dependencies (by default).
# Most other platforms have some kind of package manager.
# FIXME: consider a package manager such as conan/vcpkg instead of vendoring
if(ANDROID OR MSVC)
    set(vendored_default ON)
else()
    set(vendored_default OFF)
endif()

set(sdl2mixer_install_enableable ON)
if ((TARGET SDL2 OR TARGET SDL2-static) AND SDL2_DISABLE_INSTALL)
    # Cannot install SDL2_mixer when SDL2 is built in same built, and is not installed.
    set(sdl2mixer_install_enableable OFF)
endif()

if(NOT DEFINED CMAKE_FIND_PACKAGE_PREFER_CONFIG)
    set(CMAKE_FIND_PACKAGE_PREFER_CONFIG ON)
endif()

include(CheckIncludeFile)
include(CheckSymbolExists)
include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

include(PkgConfigHelper)

option(CMAKE_POSITION_INDEPENDENT_CODE "Build static libraries with -fPIC" ON)
option(BUILD_SHARED_LIBS "Build the library as a shared library" ON)

# Save BUILD_SHARED_LIBS variable as soon as possible
set(SDL2MIXER_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

cmake_dependent_option(SDL2MIXER_INSTALL "Enable SDL2mixer install target" ${SDL2MIXER_ROOTPROJECT} "${sdl2mixer_install_enableable}" OFF)
option(SDL2MIXER_DEPS_SHARED "Default value for loading dependencies dynamically" ON)
option(SDL2MIXER_VENDORED "Use vendored third-party libraries" ${vendored_default})

option(SDL2MIXER_SAMPLES "Build the SDL2_mixer sample program(s)" ${SDL2MIXER_SAMPLES_DEFAULT})
cmake_dependent_option(SDL2MIXER_SAMPLES_INSTALL "Install the SDL2_mixer sample program(s)" OFF "SDL2MIXER_SAMPLES;SDL2MIXER_INSTALL" OFF)

if(UNIX AND NOT APPLE)
    set(sdl2mixer_cmd_default ON)
else()
    set(sdl2mixer_cmd_default OFF)
endif()
option(SDL2MIXER_CMD "Support an external music player" ${sdl2mixer_cmd_default})

option(SDL2MIXER_FLAC "Enable FLAC music" ON)

cmake_dependent_option(SDL2MIXER_FLAC_LIBFLAC "Enable FLAC music using libFLAC" OFF SDL2MIXER_FLAC OFF)
cmake_dependent_option(SDL2MIXER_FLAC_LIBFLAC_SHARED "Dynamically load LIBFLAC" "${SDL2MIXER_DEPS_SHARED}" SDL2MIXER_FLAC_LIBFLAC OFF)

cmake_dependent_option(SDL2MIXER_FLAC_DRFLAC "Enable FLAC music using drflac" ON SDL2MIXER_FLAC OFF)

option(SDL2MIXER_GME "Support loading GME music via game-music-emu" OFF)
option(SDL2MIXER_GME_SHARED "Dynamically load libgme" "${SDL2MIXER_DEPS_SHARED}")

option(SDL2MIXER_MOD "Support loading MOD music" ON)

cmake_dependent_option(SDL2MIXER_MOD_MODPLUG "Support loading MOD music via modplug" OFF SDL2MIXER_MOD OFF)
cmake_dependent_option(SDL2MIXER_MOD_MODPLUG_SHARED "Dynamically load modplug" "${SDL2MIXER_DEPS_SHARED}" SDL2MIXER_MOD_MODPLUG OFF)

cmake_dependent_option(SDL2MIXER_MOD_XMP "Support loading MOD music via libxmp" ON SDL2MIXER_MOD OFF)
cmake_dependent_option(SDL2MIXER_MOD_XMP_LITE "Use libxmp-lite instead of libxmp" OFF "SDL2MIXER_MOD_XMP;NOT SDL2MIXER_VENDORED" OFF)
cmake_dependent_option(SDL2MIXER_MOD_XMP_SHARED "Dynamically load libxmp(-lite)" "${SDL2MIXER_DEPS_SHARED}" SDL2MIXER_MOD_XMP OFF)

if(SDL2MIXER_MOD AND NOT (SDL2MIXER_MOD_MODPLUG OR SDL2MIXER_MOD_XMP))
    message(FATAL_ERROR "MOD support was enabled (SDL2MIXER_MOD) but neither modplug (SDL2MIXER_MOD_MODPLUG) or xmp (SDL2MIXER_MOD_XMP) was enabled.")
endif()

option(SDL2MIXER_MP3 "Enable MP3 music" ON)

cmake_dependent_option(SDL2MIXER_MP3_MINIMP3 "Support loading MP3 music via minimp3" ON SDL2MIXER_MP3 OFF)

cmake_dependent_option(SDL2MIXER_MP3_MPG123 "Support loading MP3 music via MPG123" OFF SDL2MIXER_MP3 OFF)
cmake_dependent_option(SDL2MIXER_MP3_MPG123_SHARED "Dynamically load mpg123" "${SDL2MIXER_DEPS_SHARED}" SDL2MIXER_MP3_MPG123 OFF)

if(SDL2MIXER_MP3 AND NOT (SDL2MIXER_MP3_MINIMP3 OR SDL2MIXER_MP3_MPG123))
    message(FATAL_ERROR "MP3 support was enabled (SDL2MIXER_MP3) but neither minimp3 (SDL2MIXER_MP3_MINIMP3) or mpg123 (SDL2MIXER_MP3_MPG123) were enabled.")
endif()

option(SDL2MIXER_MIDI "Enable MIDI music" ON)

cmake_dependent_option(SDL2MIXER_MIDI_FLUIDSYNTH "Support FluidSynth MIDI output" ON "SDL2MIXER_MIDI;NOT SDL2MIXER_VENDORED" OFF)
cmake_dependent_option(SDL2MIXER_MIDI_FLUIDSYNTH_SHARED "Dynamically load libfluidsynth" "${SDL2MIXER_DEPS_SHARED}" SDL2MIXER_MIDI_FLUIDSYNTH OFF)

if(WIN32 OR APPLE OR HAIKU)
    cmake_dependent_option(SDL2MIXER_MIDI_NATIVE "Support native MIDI output" ON SDL2MIXER_MIDI OFF)
else()
    set(SDL2MIXER_MIDI_NATIVE OFF)
endif()

cmake_dependent_option(SDL2MIXER_MIDI_TIMIDITY "Support timidity MIDI output" ON SDL2MIXER_MIDI OFF)

if(SDL2MIXER_MIDI AND NOT (SDL2MIXER_MIDI_TIMIDITY OR SDL2MIXER_MIDI_NATIVE OR SDL2MIXER_MIDI_FLUIDSYNTH))
    message(FATAL_ERROR "MIDI support was enabled (SDL2MIXER_MIDI) but neither FluidSynth (SDL2MIXER_MIDI_FLUIDSYNTH), native (SDL2MIXER_MIDI_NATIVE) or timidity (SDL2MIXER_MIDI_TIMIDITY) was enabled")
endif()

option(SDL2MIXER_OPUS "Enable Opus music" ON)
cmake_dependent_option(SDL2MIXER_OPUS_SHARED "Dynamically load libopus" "${SDL2MIXER_DEPS_SHARED}" SDL2MIXER_OPUS OFF)

set(sdl2mixer_vorbis_strings STB TREMOR VORBISFILE)
set(SDL2MIXER_VORBIS "STB" CACHE STRING "Enable OGG Vorbis music")
set_property(CACHE SDL2MIXER_VORBIS PROPERTY STRINGS "${sdl2mixer_vorbis_strings}")
if(SDL2MIXER_VORBIS)
    if(NOT SDL2MIXER_VORBIS IN_LIST sdl2mixer_vorbis_strings)
        message(FATAL_ERROR "SDL2MIXER_VORBIS contains an invalid value (=${SDL2MIXER_VORBIS}). It must be one of ${sdl2mixer_vorbis_strings}.")
    endif()
endif()
set(SDL2MIXER_VORBIS_STB OFF)
set(SDL2MIXER_VORBIS_TREMOR OFF)
set(SDL2MIXER_VORBIS_VORBISFILE OFF)
if(SDL2MIXER_VORBIS STREQUAL "STB")
    set(SDL2MIXER_VORBIS_STB ON)
endif()
if(SDL2MIXER_VORBIS STREQUAL "TREMOR")
    set(SDL2MIXER_VORBIS_TREMOR ON)
endif()
if(SDL2MIXER_VORBIS STREQUAL "VORBISFILE")
    set(SDL2MIXER_VORBIS_VORBISFILE ON)
endif()
cmake_dependent_option(SDL2MIXER_VORBIS_TREMOR_SHARED "Dynamically load tremor library" "${SDL2MIXER_DEPS_SHARED}" SDL2MIXER_VORBIS_TREMOR OFF)
cmake_dependent_option(SDL2MIXER_VORBIS_VORBISFILE_SHARED "Dynamically load vorbisfile library" "${SDL2MIXER_DEPS_SHARED}" SDL2MIXER_VORBIS_VORBISFILE OFF)

option(SDL2MIXER_WAVE "Enable streaming WAVE music" ON)

option(SDL2MIXER_WAVPACK "Enable WavPack music" ON)
cmake_dependent_option(SDL2MIXER_WAVPACK_DSD "Enable WavPack DSD music support" OFF SDL2MIXER_WAVPACK OFF)
cmake_dependent_option(SDL2MIXER_WAVPACK_SHARED "Dynamically load WavPack library" "${SDL2MIXER_DEPS_SHARED}" SDL2MIXER_WAVPACK OFF)

if(SDL2MIXER_VORBIS_TREMOR OR SDL2MIXER_VORBIS_VORBISFILE OR SDL2MIXER_FLAC_LIBFLAC OR SDL2MIXER_OPUS)
    set(SDL2MIXER_OGG TRUE)
    set(SDL2MIXER_OGG_install FALSE)
    if(SDL2MIXER_VORBIS_VORBISFILE_SHARED OR SDL2MIXER_FLAC_SHARED OR SDL2MIXER_OPUS_SHARED)
        set(SDL2MIXER_OGG_SHARED TRUE)
        set(SDL2MIXER_OGG_install TRUE)
    else()
        set(SDL2MIXER_OGG_SHARED FALSE)
        if(NOT SDL2MIXER_BUILD_SHARED_LIBS)
            set(SDL2MIXER_OGG_install TRUE)
        endif()
    endif()
else()
    set(SDL2MIXER_OGG FALSE)
endif()

if(SDL2MIXER_BUILD_SHARED_LIBS)
    set(sdl2_mixer_export_name SDL2_mixer)
    set(sdl2_mixer_install_name_infix shared)
    set(sdl2_target_name SDL2::SDL2)
else()
    set(sdl2_mixer_export_name SDL2_mixer-static)
    set(sdl2_mixer_install_name_infix static)
    set(sdl2_target_name SDL2::SDL2-static)
endif()

sdl_find_sdl2(${sdl2_target_name} ${SDL_REQUIRED_VERSION})

set(BUILD_SHARED_LIBS ${SDL2MIXER_BUILD_SHARED_LIBS})
add_library(SDL2_mixer
    src/codecs/load_aiff.c
    src/codecs/load_voc.c
    src/codecs/mp3utils.c
    src/codecs/music_cmd.c
    src/codecs/music_drflac.c
    src/codecs/music_flac.c
    src/codecs/music_fluidsynth.c
    src/codecs/music_gme.c
    src/codecs/music_minimp3.c
    src/codecs/music_modplug.c
    src/codecs/music_mpg123.c
    src/codecs/music_nativemidi.c
    src/codecs/music_ogg.c
    src/codecs/music_ogg_stb.c
    src/codecs/music_opus.c
    src/codecs/music_timidity.c
    src/codecs/music_wav.c
    src/codecs/music_wavpack.c
    src/codecs/music_xmp.c
    src/effect_position.c
    src/effect_stereoreverse.c
    src/effects_internal.c
    src/mixer.c
    src/music.c
    src/utils.c
)
add_library(SDL2_mixer::${sdl2_mixer_export_name} ALIAS SDL2_mixer)
target_include_directories(SDL2_mixer
    PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/SDL2>"
    PRIVATE
        src
        src/codecs
)
target_compile_definitions(SDL2_mixer PRIVATE
    BUILD_SDL
    SDL_BUILD_MAJOR_VERSION=${MAJOR_VERSION}
    SDL_BUILD_MINOR_VERSION=${MINOR_VERSION}
    SDL_BUILD_MICRO_VERSION=${MICRO_VERSION}
)
target_link_libraries(SDL2_mixer PRIVATE $<BUILD_INTERFACE:${sdl2_target_name}>)
if(WIN32 AND BUILD_SHARED_LIBS)
    target_sources(SDL2_mixer PRIVATE
        version.rc
    )
endif()
set_target_properties(SDL2_mixer PROPERTIES
    DEFINE_SYMBOL DLL_EXPORT
    EXPORT_NAME ${sdl2_mixer_export_name}
    C_VISIBILITY_PRESET "hidden"
)
if(NOT ANDROID)
    set_target_properties(SDL2_mixer PROPERTIES
        DEBUG_POSTFIX "${SDL2MIXER_DEBUG_POSTFIX}"
    )
    if(APPLE)
        # the SOVERSION property corresponds to the compatibility version and VERSION corresponds to the current version
        # https://cmake.org/cmake/help/latest/prop_tgt/SOVERSION.html#mach-o-versions
        set_target_properties(SDL2_mixer PROPERTIES
            SOVERSION "${DYLIB_COMPATIBILITY_VERSION}"
            VERSION "${DYLIB_CURRENT_VERSION}"
        )
    else()
        set_target_properties(SDL2_mixer PROPERTIES
            SOVERSION "${LT_MAJOR}"
            VERSION "${LT_VERSION}"
        )
    endif()
endif()
if(SDL2MIXER_BUILD_SHARED_LIBS AND (APPLE OR (UNIX AND NOT ANDROID)))
    add_custom_command(TARGET SDL2_mixer POST_BUILD
        COMMAND "${CMAKE_COMMAND}" -E create_symlink "$<TARGET_SONAME_FILE_NAME:SDL2_mixer>" "libSDL2_mixer$<$<CONFIG:Debug>:${SDL2MIXER_DEBUG_POSTFIX}>$<TARGET_FILE_SUFFIX:SDL2_mixer>"
        # BYPRODUCTS "libSDL2_mixer$<$<CONFIG:Debug>:${SDL2MIXER_DEBUG_POSTFIX}>$<TARGET_FILE_SUFFIX:SDL2_mixer>" # Needs CMake 3.20
        WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
    )
endif()
if(SDL2MIXER_BUILD_SHARED_LIBS)
    if(WIN32 OR OS2)
        set_target_properties(SDL2_mixer PROPERTIES
            PREFIX ""
            DLL_NAME_WITH_SOVERSION FALSE
        )
    endif()
    if(OS2)

=== debian/changelog ===
libsdl2-mixer (2.8.0+dfsg-1build3) noble; urgency=medium

  * Rebuild against new libmpg123t64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 05 Apr 2024 08:20:10 +0200

libsdl2-mixer (2.8.0+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:58:00 +0000

libsdl2-mixer (2.8.0+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libflac12t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 14:54:48 +0000

libsdl2-mixer (2.8.0+dfsg-1) unstable; urgency=medium

  * New upstream stable release
  * d/copyright: Exclude vendored minimp3.
    We don't use this in Debian, so there's little value in reviewing new
    versions or tracking their copyright status in d/copyright.
  * d/copyright: Update
  * d/libsdl2-mixer-2.0-0.symbols: Update
  * d/rules: Update build options to enable/disable codecs.
    GME (game music emulation) and WavPack are disabled for now,
    to minimize dependencies and security exposure. Enabling them in
    future would be a compatible change, if a game in Debian needs them,
    but disabling them after they were enabled would be an incompatible
    change, so the conservative approach is to start small.
  * d/clean: Fix FTBFS-twice-in-a-row by removing regenerated files
    (Closes: #1046994)
  * d/gbp.conf: Only sign packaging tags, not upstream tags
  * d/gbp.conf: Rely on uscan to repack upstream source.
    This will use Files-Excluded in d/copyright, rather than separate
    configuration.
  * d/gbp.conf: Use DEP-14 branch names

 -- Simon McVittie <smcv@debian.org>  Mon, 22 Jan 2024 13:12:35 +0000

=== debian/control ===
Source: libsdl2-mixer
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>, Simon McVittie <smcv@debian.org>
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               libflac-dev,
               libfluidsynth-dev,
               libmodplug-dev,
               libmpg123-dev,
               libogg-dev,
               libopusfile-dev,
               libsdl2-dev,
               libtool,
               libvorbis-dev,
               pkg-config
Homepage: https://www.libsdl.org/projects/SDL_mixer/
Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl2-mixer
Vcs-Git: https://salsa.debian.org/sdl-team/libsdl2-mixer.git


Package: libsdl2-mixer-2.0-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: timgm6mb-soundfont | sf3-soundfont-gm
Description: Mixer library for Simple DirectMedia Layer 2, libraries
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, mixed by the popular FLAC, modplug MOD, FluidSynth and
 Timidity MIDI, Ogg Vorbis, and MAD or SMPEG MP3 libraries.
 .
 This package contains the shared library.

Package: libsdl2-mixer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libflac-dev,
         libfluidsynth-dev,
         libmodplug-dev,
         libmpg123-dev,
         libogg-dev,
         libopusfile-dev,
         libsdl2-dev,
         libsdl2-mixer-2.0-0 (= ${binary:Version}),
         libvorbis-dev,
Description: Mixer library for Simple DirectMedia Layer 2, development files
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, mixed by the popular FLAC, modplug MOD, FluidSynth and
 Timidity MIDI, Ogg Vorbis, and MAD or SMPEG MP3 libraries.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# fix for #725564
MODPLUG_INCLUDE_DIR := -I/usr/include/libmodplug

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

export DEB_CFLAGS_MAINT_APPEND  := -pipe -Wall $(MODPLUG_INCLUDE_DIR)
# bug #715461, provide default soundfont paths
export DEB_CPPFLAGS_MAINT_APPEND := -DMIX_INIT_SOUNDFONT_PATHS="\"/usr/share/sounds/sf3/default-GM.sf3\""

include /usr/share/dpkg/architecture.mk


# disable autoheader (invoked automatically by autoreconf), necessary in order
# to use debhelper compat level v10 without overriding dh-autoreconf calls
export AUTOHEADER := /bin/true
# use correct invocation of aclocal for autoreconf
export ACLOCAL := aclocal --force --install -I /usr/share/aclocal/ -I acinclude


# explicitly enable/disable all supported sound
#
# issue "disable-*-shared" flags for 'configure', otherwise SDL_mixer library
# opens those libraries in a plugin-like way (with SDL_LoadObject), and
# dpkg-shlibdeps doesn't seem to generate the needed dependencies in the binary
# library package
#
# enable external music player
confflags := --enable-music-cmd
# flac
confflags += --enable-music-flac
confflags += --enable-music-flac-libflac
confflags += --disable-music-flac-libflac-shared
confflags += --disable-music-flac-drflac
# game music emulation: disabled until someone needs it
confflags += --disable-music-gme
# MIDI
confflags += --enable-music-midi-fluidsynth
confflags += --disable-music-midi-fluidsynth-shared
confflags += --enable-music-midi-timidity
confflags += --enable-music-midi-native
# MOD
confflags += --enable-music-mod
confflags += --enable-music-mod-modplug
confflags += --disable-music-mod-mikmod
confflags += --disable-music-mod-modplug-shared
confflags += --disable-music-mod-xmp
# MP3
confflags += --enable-music-mp3
confflags += --enable-music-mp3-mpg123
confflags += --disable-music-mp3-mpg123-shared
confflags += --disable-music-mp3-mad-gpl
confflags += --disable-music-mp3-minimp3
# ogg
confflags += --enable-music-ogg
confflags += --enable-music-ogg-vorbis
confflags += --disable-music-ogg-vorbis-shared
confflags += --disable-music-ogg-tremor
confflags += --disable-music-ogg-stb
# opus
confflags += --enable-music-opus
confflags += --disable-music-opus-shared
# wav
confflags += --enable-music-wave
# WavPack: disabled until someone needs it
confflags += --disable-music-wavpack
confflags += --disable-music-wavpack-dsd
confflags += --disable-music-wavpack-shared


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(confflags)

override_dh_autoreconf:
	$(ACLOCAL)
	dh_autoreconf

override_dh_installchangelogs:
	dh_installchangelogs -- CHANGES.txt

override_dh_link:
	# fix lintian warning dev-pkg-without-shlib-symlink
	dh_link -plibsdl2-mixer-dev usr/lib/$(DEB_HOST_MULTIARCH)/libSDL2_mixer-2.0.so.0 usr/lib/$(DEB_HOST_MULTIARCH)/libSDL2_mixer-2.0.so
	dh_link --remaining-packages

override_dh_compress:
	dh_compress -Xplaymus.c -Xplaywave.c

## libsdl2-mixer 2.8.1%2Bdfsg

=== debian/changelog ===
libsdl2-mixer (2.8.1+dfsg-4) unstable; urgency=medium

  * d/rules: Include dpkg/default.mk, dpkg/buildtools.mk for
    definition of CC
    - Adjust ordering to preserve quoting in CPPFLAGS
  * d/rules: Use host ${PKG_CONFIG} to gather dlopen'd dependencies
  * d/salsa-ci.yml: Skip redundant build jobs
  * d/salsa-ci.yml: Exercise cross-compilation

 -- Simon McVittie <smcv@debian.org>  Mon, 01 Sep 2025 10:49:01 +0100

libsdl2-mixer (2.8.1+dfsg-3) unstable; urgency=medium

  * Pass CPPFLAGS to compiler when discovering shlibdeps for fluidsynth,
    silencing a blhc warning
  * Standards-Version: 4.7.2 (no changes required)
  * Fix a typo in the 2.8.1+dfsg-1 changelog

 -- Simon McVittie <smcv@debian.org>  Tue, 19 Aug 2025 09:52:14 +0100

libsdl2-mixer (2.8.1+dfsg-2) unstable; urgency=medium

  * d/libsdl2-mixer-2.0-0.symbols: Only generate dependencies on stable
    releases
  * d/control, d/rules: Switch from modplug to libxmp as recommended by
    upstream
  * d/control, d/rules, d/clean: Load libfluidsynth dynamically.
    This allows it to be relaxed from Depends to Recommends, and allows
    its -dev package to be dropped from the Depends of the -dev package,
    which in turn means that developers do not always need the fluidsynth
    service installed.
  * d/rules: Remove build option explicitly disabling mikmod.
    This backend was removed in 2.6.0.
  * d/rules: Remove option explicitly disabling libmad for MP3.
    This backend was removed in 2.6.0.

 -- Simon McVittie <smcv@debian.org>  Tue, 11 Mar 2025 11:25:34 +0000

libsdl2-mixer (2.8.1+dfsg-1) unstable; urgency=medium

  * New upstream stable release
  * d/copyright: Update
  * d/control, d/copyright: Update upstream URL references to point to Github
  * Standards-Version: 4.7.0 (no changes required)
  * d/control, d/tests: Depend on pkgconf in preference to pkg-config
  * d/rules, d/libsdl2-mixer-dev.install: Install examples as manual tests.
    Install them to a multiarch location since we don't currently have a
    libsdl2-mixer-tests package, and it doesn't seem worth adding one for
    two small manual tests.
  * d/salsa-ci.yml: Add

 -- Simon McVittie <smcv@debian.org>  Sat, 08 Feb 2025 16:08:16 +0000

=== debian/control ===
Source: libsdl2-mixer
Section: libs
Priority: optional
Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>, Simon McVittie <smcv@debian.org>
Standards-Version: 4.7.2
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               libflac-dev,
               libfluidsynth-dev,
               libmpg123-dev,
               libogg-dev,
               libopusfile-dev,
               libsdl2-dev,
               libtool,
               libvorbis-dev,
               libxmp-dev,
               pkgconf,
Homepage: https://github.com/libsdl-org/SDL_mixer
Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl2-mixer
Vcs-Git: https://salsa.debian.org/sdl-team/libsdl2-mixer.git


Package: libsdl2-mixer-2.0-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: ${dlopen:Recommends},
            timgm6mb-soundfont | sf3-soundfont-gm
Description: Mixer library for Simple DirectMedia Layer 2, libraries
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, mixed by the popular FLAC, libxmp MOD, FluidSynth and
 Timidity MIDI, Ogg Vorbis, and mpg123 MP3 libraries.
 .
 This package contains the shared library.

Package: libsdl2-mixer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libflac-dev,
         libmpg123-dev,
         libogg-dev,
         libopusfile-dev,
         libsdl2-dev,
         libsdl2-mixer-2.0-0 (= ${binary:Version}),
         libvorbis-dev,
         libxmp-dev,
Description: Mixer library for Simple DirectMedia Layer 2, development files
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, mixed by the popular FLAC, libxmp MOD, FluidSynth and
 Timidity MIDI, Ogg Vorbis, and mpg123 MP3 libraries.
 .
 This package contains the development files.

## libsdl2-mixer 2.8.1+dfsg

=== mingw/pkg-support/Makefile ===
#
# Makefile for installing the mingw32 version of the SDL2_mixer library

CROSS_PATH := /usr/local
ARCHITECTURES := i686-w64-mingw32 x86_64-w64-mingw32

all install:
	@echo "Type \"make native\" to install 32-bit to /usr"
	@echo "Type \"make cross\" to install 32-bit and 64-bit to $(CROSS_PATH)"

native:
	make install-package arch=i686-w64-mingw32 prefix=/usr

cross:
	mkdir -p $(CROSS_PATH)/cmake
	cp -rv cmake/* $(CROSS_PATH)/cmake
	for arch in $(ARCHITECTURES); do \
	    make install-package arch=$$arch prefix=$(CROSS_PATH)/$$arch; \
	done

install-package:
	@if test -d $(arch) && test -d $(prefix); then \
	    (cd $(arch) && cp -rv bin include lib $(prefix)/); \
	    sed "s|^prefix=.*|prefix=$(prefix)|" <$(arch)/lib/pkgconfig/SDL2_mixer.pc >$(prefix)/lib/pkgconfig/SDL2_mixer.pc; \
	    sed "s|^libdir=.*|libdir=\'$(prefix)/lib\'|" <$(arch)/lib/libSDL2_mixer.la >$(prefix)/lib/libSDL2_mixer.la; \
	    sed -e "s|^set[(]bindir \".*|set(bindir \"$(prefix)/bin\")|" \
	    	-e "s|^set[(]includedir \".*|set(includedir \"$(prefix)/include\")|" \
	    	-e "s|^set[(]libdir \".*|set(libdir \"$(prefix)/lib\")|" <$(arch)/lib/cmake/SDL2_mixer/sdl2_mixer-config.cmake >$(prefix)/lib/cmake/SDL2_mixer/sdl2_mixer-config.cmake; \
	else \
	    echo "*** ERROR: $(arch) or $(prefix) does not exist!"; \
	    exit 1; \
	fi

=== debian/changelog ===
libsdl2-mixer (2.8.1+dfsg-5) unstable; urgency=medium

  * d/rules, d/tests, d/libsdl2-mixer-dev.install:
    Don't build a static library.
    This won't be practically useful when "classic" SDL2 is replaced by
    sdl2-compat, which needs a shared SDL3 anyway.
  * d/watch*: Update to uscan format v5
  * d/control: Remove Rules-Requires-Root: no, unnecessary since Debian 13

 -- Simon McVittie <smcv@debian.org>  Sat, 20 Dec 2025 14:40:55 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
 Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>, Simon McVittie <smcv@debian.org>
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                libflac-dev,
                libfluidsynth-dev,

=== debian/rules ===
--- 
+++ 
@@ -2,17 +2,14 @@
 
 #export DH_VERBOSE=1
 
-# fix for #725564
-MODPLUG_INCLUDE_DIR := -I/usr/include/libmodplug
+export DEB_BUILD_MAINT_OPTIONS := hardening=+all
+export DEB_CFLAGS_MAINT_APPEND  := -pipe -Wall
 
-export DEB_BUILD_MAINT_OPTIONS := hardening=+all
+include /usr/share/dpkg/default.mk
+include /usr/share/dpkg/buildtools.mk
 
-export DEB_CFLAGS_MAINT_APPEND  := -pipe -Wall $(MODPLUG_INCLUDE_DIR)
 # bug #715461, provide default soundfont paths
-export DEB_CPPFLAGS_MAINT_APPEND := -DMIX_INIT_SOUNDFONT_PATHS="\"/usr/share/sounds/sf3/default-GM.sf3\""
-
-include /usr/share/dpkg/architecture.mk
-
+export CPPFLAGS += -DMIX_INIT_SOUNDFONT_PATHS="\"/usr/share/sounds/sf3/default-GM.sf3\""
 
 # disable autoheader (invoked automatically by autoreconf), necessary in order
 # to use debhelper compat level v10 without overriding dh-autoreconf calls
@@ -20,6 +17,11 @@
 # use correct invocation of aclocal for autoreconf
 export ACLOCAL := aclocal --force --install -I /usr/share/aclocal/ -I acinclude
 
+confflags :=
+# Static SDL2-based libraries are no longer useful with sdl2-compat,
+# which needs a shared SDL3 anyway
+confflags += --enable-shared
+confflags += --disable-static
 
 # explicitly enable/disable all supported sound
 #
@@ -29,7 +31,7 @@
 # library package
 #
 # enable external music player
-confflags := --enable-music-cmd
+confflags += --enable-music-cmd
 # flac
 confflags += --enable-music-flac
 confflags += --enable-music-flac-libflac
@@ -39,20 +41,19 @@
 confflags += --disable-music-gme
 # MIDI
 confflags += --enable-music-midi-fluidsynth
-confflags += --disable-music-midi-fluidsynth-shared
+confflags += --enable-music-midi-fluidsynth-shared
 confflags += --enable-music-midi-timidity
 confflags += --enable-music-midi-native
 # MOD
 confflags += --enable-music-mod
-confflags += --enable-music-mod-modplug
-confflags += --disable-music-mod-mikmod
-confflags += --disable-music-mod-modplug-shared
-confflags += --disable-music-mod-xmp
+confflags += --disable-music-mod-modplug
+confflags += --enable-music-mod-xmp
+confflags += --disable-music-mod-xmp-lite
+confflags += --disable-music-mod-xmp-shared
 # MP3
 confflags += --enable-music-mp3
 confflags += --enable-music-mp3-mpg123
 confflags += --disable-music-mp3-mpg123-shared
-confflags += --disable-music-mp3-mad-gpl
 confflags += --disable-music-mp3-minimp3
 # ogg
 confflags += --enable-music-ogg
@@ -70,12 +71,18 @@
 confflags += --disable-music-wavpack-dsd
 confflags += --disable-music-wavpack-shared
 
+# install manual tests to a multiarch-friendly location, since we don't have
+# a libsdl2-mixer-tests package
+confflags += --bindir=/usr/lib/$(DEB_HOST_MULTIARCH)/installed-tests/SDL2_mixer
 
 %:
 	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(confflags)
+
+override_dh_auto_install:
+	dh_auto_install -- install install-bin
 
 override_dh_autoreconf:
 	$(ACLOCAL)
@@ -91,3 +98,11 @@
 
 override_dh_compress:
 	dh_compress -Xplaymus.c -Xplaywave.c
+
+debian/shlibdeps-helper.so: debian/shlibdeps-helper.c debian/rules
+	$(CC) -shared $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -Wl,--no-as-needed \
+		-o$@ $< \
+		$$($(PKG_CONFIG) --cflags --libs fluidsynth)
+
+execute_after_dh_shlibdeps-arch: debian/shlibdeps-helper.so
+	dh_shlibdeps -plibsdl2-mixer-2.0-0 -- --warnings=0 -pdlopen -dRecommends -e$<

=== debian/watch ===
Version: 5

# Upstream releases official source tarballs, so we use
# those in preference to git tags
Source: https://github.com/libsdl-org/SDL_mixer/tags
Matching-Pattern: .*/releases/tag/(?:release)-?(2\.[0-9.]+)
Compression: gzip
Download-Url-Mangle: s#/tag/#/download/#;s#((?:prerelease|preview|release)-?@ANY_VERSION@)$#$1/SDL2_mixer-$2.tar.gz#
Dversion-Mangle: s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//
Filename-Mangle: s#(?:prerelease|preview|release)-?@ANY_VERSION@#SDL2_mixer-$1.tar.gz#
Pgp-Mode: auto
Repack: yes
Repack-Suffix: +dfsg
